/*-----------------------------------------------------------------------------
	libinet.c
		C^[lbgėpCu

	쐬			r
	쐬		1999/1/25
	ŏIXV	1999/2/20	r
-----------------------------------------------------------------------------*/
#include <string.h>		/*memset()*/
#include <unistd.h>		/*close()*/
#include <netdb.h>
#ifdef SOLARIS
#include <sys/types.h>
#endif
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "libinet.h"

/*-----------------------------------------------------------------------------
vg^CvFint lConnect( const char *srv, unsigned long int port );
		Fconst char *srv ... ڑ̃T[oB܂IPAhX
			@unsigned long int port ... ڑ̃|[gԍ
Ԓl		Fint ... F\PbgfBXNv^, ُF-1
		FsrvportŎw肳ꂽT[o֐ڑAsocket descripterԂB
쐬		Fr
쐬	F1999/2/7
ŏIXVF1999/2/7
-----------------------------------------------------------------------------*/
int lConnect( const char *srv, unsigned long int port ){

	int		sd;
	unsigned long int	ipaddr;
	struct	sockaddr_in	sv_addr;
	struct	hostent		*shost;

	if( (sd = socket( AF_INET, SOCK_STREAM, 0 )) < 0)	/*\Pbg쐬*/
		return -1;

	if( inet_addr(srv) == -1 ){		/*OŎw肵ꍇ*/
		if((shost = gethostbyname(srv)) == NULL){
			close( sd );
			return -1;
		}
	}else{							/*IPAhX̏ꍇ*/
		ipaddr = inet_addr(srv);
		if ((shost = gethostbyaddr ((char *)&ipaddr, 4, AF_INET)) == NULL){
			close( sd );
			return -1;
		}
	}

	memset ( (char *)&sv_addr, 0, sizeof(sv_addr));
	sv_addr.sin_family = AF_INET;
	sv_addr.sin_port = htons(port);
	memcpy(&sv_addr.sin_addr, (char *)shost->h_addr, shost->h_length);

	if( connect( sd, (struct sockaddr*)&sv_addr, sizeof(sv_addr) ) < 0){		/*\Pbg̐ڑv*/
		close( sd );
		return -1;
	}

	return sd;

}

void lClose( int sd ){

	shutdown( sd, 2 );
	close( sd );

	return;

}

/*-----------------------------------------------------------------------------
vg^CvFchar *nresolve( const char *hostname );
		Fconst char *hostname ... zXg
Ԓl		Fchar * ij... hostnameIPAhX
			@       isj... NULL
		Fhostname𐳈AIPAhXԂB
			@IPAhXɓnꂽꍇ̂܂ܕԂB
쐬		Fr
쐬		F1999/2/5
-----------------------------------------------------------------------------*/

char *nresolve( const char *hostname ){

	struct hostent *host;		/*host infomation*/
	struct in_addr addr;		/*IP Address*/
	char	*ipaddr;

	host = gethostbyname( hostname );
	if(host == NULL)
		return NULL;
	memcpy(&addr.s_addr, (char *)host->h_addr, host->h_length);
	ipaddr = inet_ntoa(addr);

	return ipaddr;

}


/*-----------------------------------------------------------------------------
vg^CvFchar *iresolve( const char *ipaddr );
		Fconst char *ipaddr ... tIPAhX
Ԓl		Fchar * ij... ipaddr̃zXg
			@       isj... NULL
		FIPAhXtAzXgԂB
쐬		Fr
쐬		F1999/2/5
-----------------------------------------------------------------------------*/

char *iresolve( const char *ipaddr ){

	struct				hostent *host;
	unsigned long int	naddr;			/*network byte order*/

	naddr = inet_addr( ipaddr );
	host = gethostbyaddr( (char *)&naddr, 4, AF_INET );
	if(host == NULL)
		return NULL;

	return host->h_name;

}

/*-----------------------------------------------------------------------------
vg^CvFchar *getpeerip( int sd );
		Fint sd ... ڑ̃\PbgfBXNv^
Ԓl		Fchar * ij... ڑIPAhX
			@       isj... NULL
		FڑIPAhXԂB
쐬		Fr
쐬		F1999/2/5
-----------------------------------------------------------------------------*/

char *getpeerip( int sd ){

	struct sockaddr_in addr;
	int namelen;
	char *s_ipaddr;

	namelen = sizeof( addr );
	memset((char*)&addr, 0, sizeof(addr));
	if(getpeername( sd, (struct sockaddr *)&addr, &namelen ) == -1)
		return NULL;
	s_ipaddr = inet_ntoa(addr.sin_addr);	/*network byte order -> IP Address*/

	return s_ipaddr;

}
