/*---------------------------------------------------------------------------
 * libpr.c Ver1.12
 * ʎpCu
 *
 * Last update : 1999/4/13
 *
 * Copyright(C) 1997-99  Yuto Ikeno  All rights reserved.
 * e-mail : mew@onbiz.net
 * homepage:http://www.onbiz.net/~mew/
----------------------------------------------------------------------------*/

/*--- Include ---*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <sys/file.h>		/*#ifdef LOCK_SH*/
#include "libpr.h"

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint delline (char *, unsigned int)
@@@@Fchar *fName	ΏۂƂȂt@C
@@@@@@@unsigned int 		폜si1JEgj
@@@@Fw肳ꂽt@C̎ws폜
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int delLine(char *fName, unsigned int lNumber){

	FILE			*fp;
	unsigned int	i;
	char			**buf2Dim;

	buf2Dim = readFile( fName );
	if( buf2Dim == NULL )
		return 0;

	if((fp = fopen(fName, "w")) == NULL)
		return 0;
	for (i = 0; *(buf2Dim + i) ; i++){
		if((i + 1) != lNumber)
			fputs(*(buf2Dim + i),fp);
	}
	fclose(fp);

	freeTwoDimArray(buf2Dim);

	return 1;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint addLine (char *, char *)
@@@@Fchar *filename		ΏۂƂȂt@C
@@@@@@@char *host_name 		zXg
@@@@Fw肳ꂽt@Cɍڂǉ
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int addLine(char *fName, char *addString){

	FILE	*fp;

	if((fp = fopen(fName, "a")) == NULL)
		return 0;

	fprintf(fp,"%s\n", addString);

	fclose(fp);

	return 1;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint addLineTop(const char *, const char *);
@@@@Fconst char *fName		ރt@C
@@@@@@@const char *str		ޓe
Ԃl@@@@int				1:I
@@@@@@@					0:ُI
@@@@FfpŎw肳t@C̐擪ɂPsistrjށB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int addLineTop(const char *fName, const char *str){

	unsigned int	i;
	char			**bufRead;
	FILE			*wfp;

	bufRead = readFile(fName);

	if((wfp = fopen(fName, "w")) == NULL)
		return 0;

	fprintf(wfp, "%s\n" ,str);
	for(i = 0; *(bufRead + i); i++)
		fputs(*(bufRead + i), wfp);

	fclose(wfp);

	freeTwoDimArray(bufRead);

	return 1;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFvoid freeTwoDimArray(char **, unsigned int)
@@@@Fchar **Array			񎟔zւ̃|C^
@@@@@@@unsigned int lines	񎟔z̔z
@@@@FIɊmۂꂽ񎟔zArraySĉ܂B
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
void freeTwoDimArray(char **Array){

	unsigned int	i;

	if( Array != NULL ){
		for( i = 0; *(Array + i); i++ )
				free(*(Array + i));

		if(Array)
			free(Array);
	}

	return;

}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFchar *fgetLine(FILE *);
@@@@FFILE *rfp		ǂݍރt@Cւ̃|C^
Ԃl@@@@char *		ǂݍ񂾂Ps
@@@@@@@@@@@@@@t@C̏ȈꍇNULL
@@@@FrfpŎw肳ꂽt@CPsǂݍ݁A̕i[
@@@@@@@̈ւ̃|C^ԂB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
char *fgetLine(FILE *rfp){

	char	buf[BUFSIZE];
	char	*tmp = NULL;

	while(fgets(buf, BUFSIZE, rfp) != NULL){
		if(!tmp){
			tmp = (char *)malloc(strlen(buf) + 1);
			if(tmp == NULL){
				perror("Memory allocation error.");
				return NULL;
			}
			strcpy(tmp, buf);
		}else{
			tmp = (char *)realloc((char *)tmp, strlen(tmp) + strlen(buf) + 1);
			if(tmp == NULL){
				perror("Memory reallocation error.");
				return NULL;
			}
			strcat(tmp, buf);
		}
		if(isNewLine(buf))
			return tmp;
		else if(strlen(buf) < BUFSIZE)
			return tmp;

	}
	return NULL;

}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFchar **readFile(const char *, unsigned int)
@@@@Fconst char *fName		ǂݍރt@C
@@@@@@@unsigned int lines	ǂݍރt@C̍s
߂l@@@Fchar **				Yt@C̓ei[񎟔z
@@@@FfNameŎw肳ꂽt@Cǂݍ݁Aei[񎟔zւ
@@@@@@@|C^ԂB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
char **readFile(const char *fName){

	char			*buf;
	char			**bufRead = NULL;
	FILE			*rfp;
	unsigned int	i = 0;

	if((rfp = fopen(fName, "r")) == NULL)
		return NULL;

	while((buf = fgetLine(rfp)) != NULL){
		bufRead = (char **)realloc(bufRead, sizeof(char *) * (i + 1));
		if(bufRead == NULL){
			perror("Memory reallocation error.");
			return NULL;
		}
		*(bufRead + i) = buf;
		i++;
	}
	bufRead = (char **)realloc(bufRead, sizeof(char *) * (i + 1));
	if(bufRead == NULL){
		perror("Memory reallocation error.");
		return NULL;
	}
	*(bufRead + i) = NULL;
	fclose( rfp );

	return bufRead;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFvoid removeNewline (char *)
@@@@Fchar *obj		ΏۂƂȂ镶
@@@@FobjCRA܂LF݂ꍇoĂ_ŕ؂
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
void removeNewline(char *obj){

	char	*p = obj;	/*obj̈ʒuۑ*/

	while(*obj){
		if(*obj != 0x0a && *obj != 0x0d)
			obj++;		
		else
			*obj = '\0';
	}
	obj = p;	/*ʒu*/

	return;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint isNewLine(char *);
@@@@Fchar *str		`FbN镶
Ԃl@@@@int			0Fs݂Ȃ
@@@@@@@@@@@@@@1Fs݂
@@@@Fstrɉs݂邩ǂׂ
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int isNewLine(char *str){

	char	*s = str;

	while(*str){
		if(*str == 0x0a || *str == 0x0d){
			str = s;
			return 1;
		}
		str++;
	}
	str = s;
	return 0;

}

char *emptyAlloc( void ){
	
	char	*empty;

	empty = (char *)malloc( sizeof(char) * 1 );
	if( empty == NULL )
		return NULL;
	*empty = '\0';
	
	return empty;

}

#ifndef LOCK_SH	/*---flockȂOSł̏---*/

int f_lock( int fd ){

	while( lockf(fd, F_TLOCK, 0) == -1 ){
		if( errno != EAGAIN )
			return -1;
	}
	return 0;

}

int f_unlock( int fd ){

	while( lockf(fd, F_ULOCK, 0) == -1 ){
		if( errno == EBADF || errno == ECOMM )
			return -1;
	}

	return 0;

}

#else	/*---flockOSł̏---*/

int f_lock ( int fd ){

	if(flock(fd, LOCK_EX) == -1)
		return -1;

	return 0;

}


int f_unlock ( int fd ){

	if(flock(fd, LOCK_UN) == -1)
		return -1;

	return 0;

}

#endif
/*End of file*/