/*---------------------------------------------------------------------------
 * libsec.c Ver1.2
 * CGIZLeBCu
 * for UNIX
 *
 * Last modified: 1999/2/11
 *
 * Copyright(C) 1998-99  Yuto Ikeno  All rights reserved.
 *
 * e-mail: mew@onbiz.net
 * homepage: http://www.onbiz.net/~mew/
 * support:  http://www.onbiz.net/~mew/cgi-bin/mewbbs/support/mewbbs.cgi
 * compile:  Solaris	gcc -c libsec.c -lnsl -lsocket -lresolv
 *           FreeBSD	gcc -c libsec.c
 *           IRIX		gcc -c libsec.c
 *-------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <errno.h>
#include "libinet.h"

#define TRUE 1
#define FALSE 0

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint ReverseDNS (char *)
@@@@Fchar *addr		zXg
߂l@@@FFALSE		FQDNs
@@@@@@@TRUE		FQDN
@@@@FzXgIPv邩ǂ𔻒f
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int ReverseDNS ( void ){

	char				*remotehost;
	char				*remoteaddr;
	char				*ipaddr;
	char				*hostname;

	remotehost = getenv( "REMOTE_HOST" );

	if(	remotehost != NULL ){

		ipaddr = nresolve( remotehost );
		if( ipaddr == NULL )
			return TRUE;		/*tłȂzXgpɂƂ肠TRUE*/

		remoteaddr = getenv( "REMOTE_ADDR" );
		if( remoteaddr == NULL )
			return FALSE;		/*REMOTE_ADDRȂFALSE*/

		if(!strcasecmp( remoteaddr, ipaddr )){

			hostname = iresolve( ipaddr );
			if( hostname == NULL )
				return TRUE;		/*łȂzXgpɂƂ肠TRUE*/

			if(strcasecmp( remotehost, hostname ) != 0)
				return FALSE;		/*DNSɓo^ĂzXgREMOTE_HOSTقȂĂFALSE*/

		}else{	/*REMOTE_ADDRREMOTE_HOSTIPAhXقȂĂFALSE*/

			return FALSE;

		}
	}
	return TRUE;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint isIPAddress (char *)
@@@@Fchar *remote_addr		zXgiREMOTE_HOSTnj
߂l@@@FFALSE		zXgł
@@@@@@@TRUE		IPł
@@@@FREMOTE_HOSTɊi[ꂽlzXgIPAhX𒲂ׂ
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int isIPAddress (char *remote_host){

	if( inet_addr( remote_host ) == -1 )
		return FALSE;

	return TRUE;

}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint IsProxy ()
߂l@@@FFALSE		Ă/ s\
@@@@@@@TRUE		ȂȂ
@@@@Fw肵IP̓|[g֐ڑs
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int IsProxy ( void ){

	int					i;
	int					sd;
	char *				srv;

	unsigned int	Port[] = {80, 3128, 8000, 8080, 0};

	if ((srv = getenv ("REMOTE_ADDR")) == NULL)
		return FALSE;

	for( i = 0; Port[i] != 0; i++ ){
		if((sd = lConnect( srv, Port[i] )) != -1){
			lClose( sd );
			return FALSE;
		}
		lClose( sd );
	}
	return TRUE;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint ViaProxy ()
߂l@@@FFALSE		PROXYoR
@@@@@@@TRUE		PROXYoRĂȂ
@@@@FϐPROXYT[ooRo
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int ViaProxy ( void ){

	char *				lpHost;

	if (getenv ("HTTP_VIA") != NULL)
		return (FALSE);

	if (getenv ("HTTP_FORWARDED") != NULL)
		return (FALSE);

	if (getenv ("HTTP_X_FORWARDED_FOR") != NULL)
		return (FALSE);

	if ((lpHost = getenv ("REMOTE_HOST")) != NULL)
	{
		if (strstr (lpHost, "gate") != NULL)
			return (FALSE);

		if (strstr (lpHost, "cache") != NULL)
			return (FALSE);

		if (strstr (lpHost, "proxy") != NULL)
			return (FALSE);
	}
	return (TRUE);
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint isAnonymousProxy ();
߂l@@@FFALSE		PROXYoR
@@@@@@@TRUE		PROXYoRĂȂ
@@@@Fϐ瓽PROXYT[ooRo
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int isAnonymousProxy ( void ){

	if (getenv ("HTTP_X_FORWARDED_FOR") != NULL)
		return (FALSE);

	return TRUE;

}